unit catamain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Menus, Shellapi;

type
  TForm1 = class(TForm)
    CatName: TLabel;
    CatFiles: TLabel;
    CatBytes: TLabel;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    CaseSen: TCheckBox;
    SG: TStringGrid;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit2: TMenuItem;
    Help1: TMenuItem;
    OpenCatalog1: TMenuItem;
    SaveNow1: TMenuItem;
    Options1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    AddCD1: TMenuItem;
    OpenDialog1: TOpenDialog;
    QuickHelp1: TMenuItem;
    About1: TMenuItem;
    procedure movestuff(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ReadOptions(Sender: TObject);
    procedure CloseStuff(Sender: TObject; var CanClose: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure CaseSenClick(Sender: TObject);
    procedure UpdateInfo(sender : TObject);
    Procedure OpenCatalog;
    Procedure SaveCatalog;
    procedure SaveNow1Click(Sender: TObject);
    procedure AddCD1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure OpenCatalog1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure QuickHelp1Click(Sender: TObject);
  private
    { Private declarations }
  public


    opCS,opSaveOnExit : boolean;
    opCDDrive : string;
    CName : string;
  end;

  TEntry = record
           CD : string[41];
           fn : string[141];
           fs, hs : cardinal;
           end;
  CFile = file of tentry;
  Tarr = array [1..1000000] of Tentry;
  TArrPtr = ^Tarr;


const HTableSize = 1024*1024;

var
  Form1: TForm1;
  cnt : longint;
  A : TArrPtr;
  cntbytes : extended;
  canrelease : boolean;
  hTable : array [0..HTableSize - 1] of boolean;

implementation

uses CatOpt, catadd, abotubox;

{$R *.DFM}

function ReadableBytes(a : extended) : string;
 var n,r : string;
 begin
 n := 'bytes';

 if a > 1024 then
  begin
  a := a / 1024;
  n := 'K';
  end;
 if a > 1024 then
  begin
  a := a / 1024;
  n := 'M';
  end;
 if a > 1024 then
  begin
  a := a / 1024;
  n := 'G';
  end;

     if a < 10 then str(a:1:2,r)
else if a < 100 then str(a:1:1,r) else str(a:1:0,r);
 readableBytes := r+' '+n;
 end;


function hash(s1,s2 : string; ek : cardinal) : cardinal;
 var h,n : cardinal;
     i : integer;
     k,e : extended;
 begin
 k := 1 ;
 for i := 1 to 32 do k := k * 2;
 while length(s1) mod 4 <> 0 do s1 := s1 + ' ';
 while length(s2) mod 4 <> 0 do s2 := s2 + ' ';
 h := 0;
 for i := 0 to length(s1) div 4 - 1 do
  begin
  n := ord(s1[i*4+1]);
  n := n * 256 + ord(s1[i*4+2]);
  n := n * 256 + ord(s1[i*4+3]);
  n := n * 256 + ord(s1[i*4+4]);
  e := h+n;
  if e > k-1 then e := e - k;
  h := round(e);
  end;
 s1 := s2;
 for i := 0 to length(s1) div 4 - 1 do
  begin
  n := ord(s1[i*4+1]);
  n := n * 256 + ord(s1[i*4+2]);
  n := n * 256 + ord(s1[i*4+3]);
  n := n * 256 + ord(s1[i*4+4]);
  e := h+n;
  if e > k-1 then e := e - k;
  h := round(e);
  end;
 n := ek;
 e := h+n;
 if e > k-1 then e := e - k;
 h := round(e);
 hash := h;
 end;

Procedure TForm1.OpenCatalog;
 var f : CFile;
     i : integer;
 begin
 if not fileexists(Cname) then
  begin
  assignfile(f,cname);
  rewrite(f);
  closefile(f);
  end;
 assignfile(F,cname);
 reset(f);
 cnt := filesize(f);
 if canrelease then freemem(a);
 canrelease := true;
 getmem(a,(cnt+1)*sizeof(tentry));
 if cnt > 0 then blockread(f,a^,cnt);
 closefile(f);
 for i := 1 to cnt do htable[a^[i].hs mod htablesize]:= true;
 end;


Procedure TForm1.SaveCatalog;
 var f : CFile;
 begin
 assignfile(F,cname);
 rewrite(f);
 blockwrite(f,a^,cnt);
 closefile(f);
 end;



procedure TForm1.movestuff(Sender: TObject);
begin
 CatName.Left  := Form1.ClientWidth - 166;
 CatBytes.Left := Form1.ClientWidth - 166;
 CatFiles.Left := Form1.ClientWidth - 166;
 SG.Width      := Form1.Clientwidth - 16;
 SG.Height     := Form1.height - 116;
 SG.ColWidths[0] := (SG.clientWidth * 3) div 7 - 1 ;
 SG.ColWidths[1] := (SG.clientWidth * 3) div 7 - 1;
 SG.ColWidths[2] :=  SG.clientWidth  div 7 - 1;
end;

Procedure TForm1.ReadOptions(Sender : TOBject);
 var t  : TextFile;
     s  : string;

Procedure readbooloption(src,caption : string; var b : boolean);
 begin
 if pos(caption,src)=1 then
  b := (copy(src,length(caption)+1,255)='TRUE');
 end;

Procedure readstroption(src,caption : string; var b : string);
 begin
 if pos(caption,src)=1 then
  b := copy(src,length(caption)+1,255);
 end;



 begin
 if not fileexists('catalog.cfg') then
  begin
  opCS := false;
  opCDDrive := 'D:';
  opSaveOnExit := TRUE;
  Cname := 'default.cat';
  showmessage('You are running this program for the first time, please set up the options');
  end
  else
  begin
  AssignFIle(t, 'catalog.cfg');
  Reset(t);
  while not seekeof(t) do
   begin
   readln(t,s);
   ReadBoolOption(s,'CaseSensitive=',opCS);
   ReadStrOption (s,'CDDrive=',opCDDrive);
   ReadBoolOption(s,'SaveOnExit=',opSaveOnExit);
   ReadStrOption (s,'LastCat=',CName);
   end;
  CLoseFile(t);
  end;
 CaseSen.checked := opCS;
 end;

procedure TForm1.FormCreate(Sender: TObject);
 var i : longint;
begin
 canrelease := false;
 for i := 0 to htableSize-1 do HTable[i] := FALSE;
 SG.Cells[0,0] := 'CD';
 SG.Cells[1,0] := 'File Name';
 SG.Cells[2,0] := 'File Size';
 ReadOptions(self);
 OpenCatalog;
 UpdateInfo(self);
end;

function boolstr(a : boolean) : string;
 begin
 if a then boolstr := 'TRUE'
      else boolstr := 'FALSE';
 end;

procedure TForm1.CloseStuff(Sender: TObject; var CanClose: Boolean);
 var t : textFile;
begin
 AssignFile(t, 'catalog.cfg');
 Rewrite(t);
 writeln(t,'CaseSensitive='+boolstr(opCS));
 writeln(t,'CDDrive='+opCDDrive);
 writeln(t,'SaveOnExit='+boolstr(opSaveOnExit));
 writeln(t,'LastCat='+CName);
 CloseFile(t);
 if opSaveOnExit then SaveCatalog;



 CanClose := true;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Options1Click(Sender: TObject);
begin
 form2.showmodal;
end;

procedure TForm1.CaseSenClick(Sender: TObject);
begin
 OpCS := CaseSen.checked;
end;

Procedure TForm1.UpdateInfo(sender : TObject);
 var i : integer;
 begin
 CatName.Caption := 'Current Catalog: '+Cname;
 CatFiles.caption := 'Indexing: '+inttostr(cnt)+' files';
 cntBytes := 0;
 for i := 1 to cnt do cntBytes := cntBytes + a^[i].fs;
 CatBytes.caption := 'Indexing: '+ReadableBytes(cntbytes);
 end;

procedure TForm1.SaveNow1Click(Sender: TObject);
begin
 SaveCatalog;
end;


function eq(var a,b : tentry) : boolean;
 begin
 eq := (a.fn = b.fn) and
       (a.fs = b.fs) and
       (a.cd = b.cd);
 end;


procedure TForm1.AddCD1Click(Sender: TObject);
 var v,i : longint;
     t : TextFile;
     b : TarrPtr;
     addcnt : longint;
     cd : string;
     s : string;
     fs : cardinal;
     hs : cardinal;
     sha : boolean;
     g : TEntry;
begin
 v := form3.showmodal;
 if v = mrOk then
  begin
  assignfile(t, 'add.cnt');
  reset(t);
  readln(t, addcnt);
  closefile(t);

  Getmem(b,(cnt+addcnt)*sizeof(tentry));
  for i := 1 to cnt do b^[i] := a^[i];
  freemem(a);
  a := b;
  assignfile(t,'add.tmp');
  reset(t);
  readln(t, cd);
  for i := 1 to addcnt do
   begin
   readln(t, s);
   readln(t, fs);
   hs := Hash(cd,s,fs);
   g.cd := cd;
   g.fn := s;
   g.fs := fs;
   g.hs := hs;
   sha := true;
   if htable[hs mod htablesize] then
    begin
    for i := 1 to cnt do if eq(g,a^[i]) then sha := false;
    end;
   if sha then
    begin
    inc(cnt);
    a^[cnt] := g;
    HTable[hs mod HTableSize] := true;
    end;
   end;
  closefile(t);
  UpdateInfo(self);
  end;
end;

procedure UpString(var s : string);
 var i : integer;
 begin
 for i := 1 to length(s) do s[i] := upCase(s[i]);
 end;

procedure TForm1.Button1Click(Sender: TObject);
 var i,r : integer;
     e1,e2 : string;
begin
 if edit1.text='' then exit;
 e1 := edit1.text;
 if not opCS then UpString(e1);
 SG.rowcount := 1;
 for i := 1 to cnt do
  begin
  e2 := a^[i].fn;
  if not opCS then UpString(e2);
  if pos(e1,e2) <> 0 then
   begin
   r := SG.RowCount;
   SG.RowCount := r+1;
   SG.Cells[0,r] := a^[i].cd;
   SG.Cells[1,r] := a^[i].fn;
   SG.Cells[2,r] := inttostr(a^[i].fs);
   end;
  end;
 if SG.RowCount = 1 then
  begin
  SG.RowCount := 2 ;
  SG.Cells[0,1] := 'No files were found!';
  SG.Cells[1,1] := 'Search again ...';
  SG.Cells[2,1] := '';
  end;
 SG.FixedRows := 1;
 SG.ColWidths[0] := (SG.clientWidth * 3) div 7 - 1 ;
 SG.ColWidths[1] := (SG.clientWidth * 3) div 7 - 1;
 SG.ColWidths[2] :=  SG.clientWidth  div 7 - 1;
end;

procedure TForm1.OpenCatalog1Click(Sender: TObject);
begin
 if OpenDialog1.execute then
  begin
  if opSaveOnExit then SaveCatalog;
  cname := extractfilename(Opendialog1.filename);
  openCatalog;
  updateinfo(self);
  end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Form4.showmodal;
end;

procedure TForm1.QuickHelp1Click(Sender: TObject);
begin
 if not fileexists('Cat.html') then
  showmessage('Help file "Cat.html" not found :(')
   else
  ShellExecute(0,pchar('open'),pchar('Cat.html'),pchar(''),pchar(''),SW_SHOWNORMAL);
end;

end.
